CREATE OR REPLACE
PACKAGE UTIL_CRIAVENCIMENTO AS
      FUNCTION DIAMES(P_CDFORMPGTO IN VARCHAR2,
                      P_DTVENCIMENTO IN DATE)
                RETURN DATE;
      PRAGMA RESTRICT_REFERENCES (DIAMES, WNDS, WNPS);

      FUNCTION DIASEMANA(P_CDFORMPGTO IN VARCHAR2,
                         P_DTVENCIMENTO IN DATE)
               RETURN DATE;
      PRAGMA RESTRICT_REFERENCES (DIASEMANA, WNDS, WNPS);

      FUNCTION DIASEMANAMES(P_CDFORMPGTO IN VARCHAR2,
                            P_DTVENCIMENTO IN DATE)
               RETURN DATE;

      PRAGMA RESTRICT_REFERENCES (DIASEMANAMES, WNDS, WNPS);

END UTIL_CRIAVENCIMENTO;
/

CREATE OR REPLACE
PACKAGE BODY UTIL_CRIAVENCIMENTO AS
   FUNCTION DIAMES (P_CDFORMPGTO IN VARCHAR2,
                    P_DTVENCIMENTO IN DATE)
            RETURN DATE AS

      V_BASEDIA       VARCHAR2(2);
      V_DTVENCIMENTO  DATE;

      V_NRDIAPGTOVAR  VARCHAR2(2);
      V_NRMESFORMPGT  NUMBER;
      V_NRNUMMESPGTO  NUMBER;

      V_INVERICAMES   NUMBER;
      V_INDIAS        NUMBER;

   BEGIN
       V_DTVENCIMENTO := P_DTVENCIMENTO;

       V_BASEDIA :=  TO_CHAR(V_DTVENCIMENTO, 'DD');

       Begin
           SELECT NRDIAPGTOVAR, NRMESFORMPGT, NVL(NRNUMMESPGTO, 1) AS NRNUMMESPGTO
             INTO V_NRDIAPGTOVAR, V_NRMESFORMPGT, V_NRNUMMESPGTO
             FROM DIAPGTO
            WHERE CDFORMPGTO = P_CDFORMPGTO
              AND NRDIAINIPGTO <= V_BASEDIA
              AND NRDIAFINPGTO >= V_BASEDIA;
       Exception
          When No_Data_Found Then
             V_NRDIAPGTOVAR := Null; V_NRMESFORMPGT := Null; V_NRNUMMESPGTO := Null;
       End;

       IF V_NRMESFORMPGT = 0 THEN
          V_INVERICAMES := 0;
       ELSE
          V_INVERICAMES := V_NRNUMMESPGTO;
       END IF;

       IF NOT V_NRDIAPGTOVAR IS NULL THEN
          V_DTVENCIMENTO := ADD_MONTHS(V_DTVENCIMENTO, V_INVERICAMES);

          V_INDIAS :=  TO_NUMBER(TO_CHAR(LAST_DAY(V_DTVENCIMENTO), 'DD'));

          IF V_NRDIAPGTOVAR > V_INDIAS THEN
             V_DTVENCIMENTO := LAST_DAY(V_DTVENCIMENTO);
          ELSE
             /*Joga a data com o dia informado na parametrizcao */
             V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAPGTOVAR)||'/'||TO_CHAR(V_DTVENCIMENTO, 'MM/YYYY'), 'DD/MM/YYYY');
          END IF;
       END IF;

       RETURN(V_DTVENCIMENTO);
   END;


   FUNCTION DIASEMANA (P_CDFORMPGTO IN VARCHAR2,
                       P_DTVENCIMENTO IN DATE)
            RETURN DATE AS

      V_BASEDIA       VARCHAR2(2);
      V_DTVENCIMENTO  DATE;

      V_NRDIAPGTOVAR  VARCHAR2(2);
      V_NRMESFORMPGT  NUMBER;
      V_NRNUMMESPGTO  NUMBER;
   BEGIN
       V_DTVENCIMENTO := P_DTVENCIMENTO;

       V_BASEDIA := LPAD(TO_CHAR(V_DTVENCIMENTO, 'D'), 2, '0');

       Begin
           SELECT NRDIAPGTOVAR, NRMESFORMPGT, NVL(NRNUMMESPGTO, 1) AS NRNUMMESPGTO
             INTO V_NRDIAPGTOVAR, V_NRMESFORMPGT, V_NRNUMMESPGTO
             FROM DIAPGTO
            WHERE CDFORMPGTO = P_CDFORMPGTO
              AND NRDIAINIPGTO <= V_BASEDIA
              AND NRDIAFINPGTO >= V_BASEDIA;
       Exception
          When No_Data_Found Then
             V_NRDIAPGTOVAR := Null; V_NRMESFORMPGT := Null; V_NRNUMMESPGTO := Null;
       End;


       IF NOT V_NRDIAPGTOVAR IS NULL THEN /*Se h dia para pagamento cadastrado */

          IF V_NRMESFORMPGT = 0 THEN  /*Semana para pagamento Atual*/
             IF LPAD(TO_CHAR(V_DTVENCIMENTO, 'D'), 2, '0') = V_NRDIAPGTOVAR THEN /*Se dia para pagamento j esta correto*/
                V_DTVENCIMENTO := V_DTVENCIMENTO +7;
             ELSE
                WHILE LPAD(TO_CHAR(V_DTVENCIMENTO, 'D'), 2, '0') <> V_NRDIAPGTOVAR  LOOP
                   V_DTVENCIMENTO := V_DTVENCIMENTO+1;
                END LOOP;
             END IF;
          ELSE /*Semana para pagamento Seguinte*/
             IF LPAD(TO_CHAR(V_DTVENCIMENTO, 'D'), 2, '0') = V_NRDIAPGTOVAR THEN /*Se dia para pagamento j esta correto*/
                V_DTVENCIMENTO := V_DTVENCIMENTO +7;
             ELSE
               IF LPAD(TO_CHAR(V_DTVENCIMENTO, 'D'), 2, '0') < V_NRDIAPGTOVAR THEN
                   V_DTVENCIMENTO := V_DTVENCIMENTO +7;
               END IF;

                WHILE LPAD(TO_CHAR(V_DTVENCIMENTO, 'D'), 2, '0') <> V_NRDIAPGTOVAR  LOOP
                   V_DTVENCIMENTO := V_DTVENCIMENTO+1;
                END LOOP;
             END IF;

          END IF;
       END IF;
       RETURN(V_DTVENCIMENTO);
   END;

   FUNCTION DIASEMANAMES (P_CDFORMPGTO IN VARCHAR2,
                          P_DTVENCIMENTO IN DATE)
            RETURN DATE AS

      V_BASEDIA       VARCHAR2(2);
      V_DTVENCIMENTO  DATE;

      V_NRDIAPGTOVAR  VARCHAR2(2);
      V_NRMESFORMPGT  NUMBER;
      V_NRNUMMESPGTO  NUMBER;
   BEGIN
       V_DTVENCIMENTO := P_DTVENCIMENTO;

       V_BASEDIA := TO_CHAR(V_DTVENCIMENTO, 'DD');

       Begin
           SELECT NRDIAPGTOVAR, NRMESFORMPGT, NVL(NRNUMMESPGTO, 1) AS NRNUMMESPGTO
             INTO V_NRDIAPGTOVAR, V_NRMESFORMPGT, V_NRNUMMESPGTO
             FROM DIAPGTO
            WHERE CDFORMPGTO = P_CDFORMPGTO
              AND NRDIAINIPGTO <= V_BASEDIA
              AND NRDIAFINPGTO >= V_BASEDIA;
       Exception
          When No_Data_Found Then
             V_NRDIAPGTOVAR := Null; V_NRMESFORMPGT := Null; V_NRNUMMESPGTO := Null;
       End;

       IF NOT V_NRDIAPGTOVAR IS NULL THEN
          V_DTVENCIMENTO := TO_DATE('01/'||TO_CHAR(V_DTVENCIMENTO, 'MM/YYYY'), 'DD/MM/YYYY');
          IF NOT V_NRMESFORMPGT = 0 THEN
             V_DTVENCIMENTO := ADD_MONTHS(V_DTVENCIMENTO, V_NRMESFORMPGT);
          END IF;

          IF V_NRNUMMESPGTO = 2 THEN
             V_DTVENCIMENTO := V_DTVENCIMENTO + 7;
          ELSIF V_NRNUMMESPGTO = 3 THEN
             V_DTVENCIMENTO := V_DTVENCIMENTO + 14;
          ELSIF V_NRNUMMESPGTO = 4 THEN
             V_DTVENCIMENTO := V_DTVENCIMENTO + 21;
          END IF;

          IF LPAD(TO_CHAR(V_DTVENCIMENTO, 'D'), 2, '0') <> V_NRDIAPGTOVAR THEN
             WHILE LPAD(TO_CHAR(V_DTVENCIMENTO, 'D'), 2, '0') <> V_NRDIAPGTOVAR LOOP
                V_DTVENCIMENTO := V_DTVENCIMENTO + 1;
             END LOOP;
          END IF;
       END IF;

       RETURN(V_DTVENCIMENTO);
   END; 

END UTIL_CRIAVENCIMENTO;
/

-- VERSAO --
BEGIN atuverobj('UTIL_CRIAVENCIMENTO','5.11.000'); END;
/

