/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3911_CDPSTP0.SQL

@C:\Web_411\Sql\End_Conv\Oracle\3910_CDPSTPO_GERA_CALE_PRODU.SQL

Descrio:
Rotina para gerao do calendrio da produo.

Criao:
23/09/2004 - Fabrcio Marcelo da Silva
*/


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'GERA_CALE_PRODU'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE GERA_CALE_PRODU
  GO

CREATE PROCEDURE GERA_CALE_PRODU
                                 @P_CDFILIAL      VARCHAR(4),
                                 @P_DTMRP         DATETIME,
                                 @P_IDESTOQUE     VARCHAR(1),
                                 @P_CDPRODUTO     VARCHAR(10),
                                 @P_DTENTPROD     DATETIME,
                                 @P_NRORDENAOP    VARCHAR(10),
                                 @P_NRORDENASUBOP VARCHAR(1),
                                 @P_IDSUBOPINSU   VARCHAR(1),
                                 @P_CDPRODFINAL   VARCHAR(10),
                                 @P_QTAFABRICDIA  DOUBLE PRECISION,
                                 @P_ORDENAPRODUCAO DOUBLE PRECISION,
                                 @P_QTESTOQUE  DOUBLE PRECISION,
                                 @P_NRORDEMPROD DOUBLE PRECISION OUTPUT
AS
   DECLARE @V_QTAFABRICARR   DOUBLE PRECISION;
   DECLARE @V_QTHORASPROD    DOUBLE PRECISION;
   DECLARE @V_DTAPRODUZIR    DATETIME;
   DECLARE @V_DTPRODUCAO     DATETIME;
   DECLARE @V_QTFABLOTEDIA   DOUBLE PRECISION;
   DECLARE @V_QTTOTFABDIA    DOUBLE PRECISION;
   DECLARE @V_NRLOTESDIAS    INT;
   DECLARE @V_NRTOTLOTEDIA   INT;
   DECLARE @V_NRSEQLOTEDIA   VARCHAR(3);
   DECLARE @V_VEXISHORATUR   VARCHAR(4);
   DECLARE @V_TURNOINIANT    VARCHAR(4);
   DECLARE @V_TURNOFIMANT    VARCHAR(4);
   DECLARE @V_TURNOAUXI      VARCHAR(4);
   DECLARE @V_DTTURNOAUXI    DOUBLE PRECISION;
   DECLARE @V_IDSUBOPSEMIACA VARCHAR(1);
   DECLARE @V_NRORDENAOP     VARCHAR(10);
   DECLARE @V_NRORDENASUBOP  VARCHAR(1);
   DECLARE @V_LOTEDISPON     VARCHAR(1);
   DECLARE @V_IDUTEQUIPLAPROD VARCHAR(1);
   DECLARE @V_QTEQUIPPRODU DOUBLE PRECISION;
   DECLARE @V_DTPRODEQUIP DATETIME;
   DECLARE @V_QTDEMINUTOSUTI DOUBLE PRECISION;
   DECLARE @V_DTRESEREQUIP DATETIME;
   DECLARE @V_CONTATIV     INT;
   DECLARE @V_DTPRODFINAL  DATETIME;
   DECLARE @V_CDCHAVE VARCHAR(50);
   DECLARE @V_DTATIVANT DATETIME;
   DECLARE @V_GERACALE VARCHAR(1);
   DECLARE @V_QTAFABRICDIA DOUBLE PRECISION;
   DECLARE @V_SALDO DOUBLE PRECISION;
   DECLARE @V_NRORDEMPROD DOUBLE PRECISION;

   DECLARE @C_DADOS_NRORDETFAB VARCHAR(3);
   DECLARE @C_DADOS_NRINSPETAPA VARCHAR(3)
   DECLARE @C_DADOS_NRORDUTRECUR VARCHAR(3)
   DECLARE @C_DADOS_CDINSPECAO VARCHAR(10);
   DECLARE @C_DADOS_CDPROCFABRIC VARCHAR(10);
   DECLARE @C_DADOS_CDETAPAPROD VARCHAR(10);
   DECLARE @C_DADOS_CDGRUPOEQUIPA VARCHAR(10);
   DECLARE @C_DADOS_NRORDINSETAP VARCHAR(3);
   DECLARE @C_DADOS_QTHRUTRECUR DOUBLE PRECISION;
   DECLARE @C_DADOS_IDRECURETAPA VARCHAR(1);
   DECLARE @C_DADOS_QTHRSETUPRECUR DOUBLE PRECISION;
   DECLARE @C_DADOS_NRRECURETAPA VARCHAR(3);
   DECLARE @C_DADOS_QTHRRECURSO DOUBLE PRECISION;
   DECLARE @C_DADOS_CDCHAVE VARCHAR(50);

   DECLARE @C_PRODARRED_QTPADPRODPCP DOUBLE PRECISION;
   DECLARE @C_PRODARRED_QTLOTEFABDIA DOUBLE PRECISION;
   DECLARE @C_PRODARRED_IDPROPORCAO VARCHAR(1);
   DECLARE @C_PRODARRED_IDARREDONDA VARCHAR(1);

   DECLARE @C_PRODMRP_CDPERIPRODU VARCHAR(2);
   DECLARE @C_PRODMRP_QTHRSEGPROD DOUBLE PRECISION;
   DECLARE @C_PRODMRP_QTLOTEFABDIA DOUBLE PRECISION;
   DECLARE @C_PRODMRP_QTPADPRODPCP DOUBLE PRECISION;
   DECLARE @C_PRODMRP_QTPADPRODUCAO DOUBLE PRECISION;
   DECLARE @C_PRODMRP_IDPROPORCAO VARCHAR(1);
   DECLARE @C_PRODMRP_IDARREDONDA VARCHAR(1);


   DECLARE @C_EQUIPAMENTOS_NRORDUTILEQUIP VARCHAR(10);
   DECLARE @C_EQUIPAMENTOS_CDEQUIPPRO VARCHAR(10);
   DECLARE @C_EQUIPAMENTOS_VRCAPEQUIPPROD DOUBLE PRECISION;
   DECLARE @C_EQUIPAMENTOS_QTHRUTIEQUIPROD DOUBLE PRECISION;
   DECLARE @C_EQUIPAMENTOS_IDLIBERAEQUIPA VARCHAR(1);
   DECLARE @C_EQUIPAMENTOS_IDEQUIPPADRAO  VARCHAR(1);
BEGIN


   SET @V_NRORDENAOP = @P_NRORDENAOP;
   SET @V_NRORDENASUBOP = @P_NRORDENASUBOP;
   SET @V_QTAFABRICARR = 0;
   SET @V_GERACALE = 'S';

/* Arredonda a quantidade a fabricar de acordo com o processo de fabricao */
   DECLARE C_PRODARRED CURSOR FOR
                           SELECT
                               QTPADPROCFAB AS QTPADPRODPCP,
                               QTLOTEFABDIA,
                               IDTPPROPOPF AS IDPROPORCAO,
                               IDTPARREDPF AS IDARREDONDA
                            FROM
                               PROCFABRICA
                            WHERE
                               (CDFILIAL     = @P_CDFILIAL)  AND
                               (CDPRODUTO    = @P_CDPRODUTO) AND
                               (IDPROFABPADR = 'S');

   OPEN C_PRODARRED;
   FETCH NEXT FROM C_PRODARRED INTO @C_PRODARRED_QTPADPRODPCP, @C_PRODARRED_QTLOTEFABDIA, @C_PRODARRED_IDPROPORCAO, @C_PRODARRED_IDARREDONDA
  
   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @C_PRODARRED_IDPROPORCAO = 'L' BEGIN
         IF @C_PRODARRED_IDARREDONDA = '1' BEGIN

            IF ((CONVERT(INT, @P_QTAFABRICDIA) % CONVERT(INT, @C_PRODARRED_QTPADPRODPCP)) <> 0) BEGIN
               SET @V_QTAFABRICARR = ((ROUND(@P_QTAFABRICDIA / @C_PRODARRED_QTPADPRODPCP,0,0) + 1) * @C_PRODARRED_QTPADPRODPCP);
            END
            ELSE BEGIN
               SET @V_QTAFABRICARR = ((@P_QTAFABRICDIA / @C_PRODARRED_QTPADPRODPCP) * @C_PRODARRED_QTPADPRODPCP);
            END;

         END
         ELSE BEGIN
            IF @C_PRODARRED_IDARREDONDA = '2' BEGIN
               SET @V_QTAFABRICARR = ((ROUND(@P_QTAFABRICDIA / @C_PRODARRED_QTPADPRODPCP,0,0)) * @C_PRODARRED_QTPADPRODPCP);
            END;
         END;
      END
      ELSE BEGIN
         IF @C_PRODARRED_IDPROPORCAO IN ('N', 'U') BEGIN
            SET @V_QTAFABRICARR = @V_QTAFABRICARR + @P_QTAFABRICDIA;
         END
         ELSE BEGIN
            SET @V_QTAFABRICARR = @V_QTAFABRICARR + @C_PRODARRED_QTPADPRODPCP;
         END;
      END;
      FETCH NEXT FROM C_PRODARRED INTO @C_PRODARRED_QTPADPRODPCP, @C_PRODARRED_QTLOTEFABDIA, @C_PRODARRED_IDPROPORCAO, @C_PRODARRED_IDARREDONDA
   END;

   CLOSE C_PRODARRED;
   DEALLOCATE C_PRODARRED;

/* GERA A ORDENACAO PARA A VERIFICAO DOS SEMIACABADOS DE ACORDO COM O CALENDARIO DA PRODUCAO*/
   IF @P_ORDENAPRODUCAO IS NULL BEGIN

      SELECT @V_NRORDEMPROD = MAX(ISNULL(NRORDEMPROD,0)) + 1
      FROM CALEPRODMRP
      WHERE
         CDFILIAL = @P_CDFILIAL AND
         DTPROGPRODCP = @P_DTMRP;

      IF @V_NRORDEMPROD IS NULL BEGIN
         SET @V_NRORDEMPROD = 1;
      END;
   END
   ELSE BEGIN
      SET @V_NRORDEMPROD = @P_ORDENAPRODUCAO;
   END;

/* Monta o Calendrio da Produo */
   
   DECLARE C_PRODMRP CURSOR FOR
                     SELECT
                         PA.CDPERIPRODU,
                         ISNULL(PA.QTHRSEGPROD,0) AS QTHRSEGPROD,
                         CONVERT( DOUBLE PRECISION,  (CASE ISNULL(IDAPLICHRSEG, 'L' ) WHEN 'L' THEN ISNULL(PA.QTHRSEGPROD,0) ELSE 0 END)) AS QTHRSEGPROD,
                         QTLOTEFABDIA,
                         QTPADPROCFAB QTPADPRODPCP,
                         (QTPADPROCFAB * QTLOTEFABDIA) AS QTPADPRODUCAO,
                         P.IDTPPROPOPF AS IDPROPORCAO,
                         P.IDTPARREDPF AS IDARREDONDA
                      FROM
                         PROCFABRICA P,
                         PARAMPRODMRP PA
                      WHERE
                         (PA.CDFILIAL       = P.CDFILIAL)  AND
                         (PA.CDPRODUTO      = P.CDPRODUTO) AND
                         (P.CDFILIAL     = @P_CDFILIAL)  AND
                         (P.CDPRODUTO    = @P_CDPRODUTO) AND
                         (P.IDPROFABPADR = 'S');
   
   OPEN C_PRODMRP;
   FETCH NEXT FROM C_PRODMRP INTO @C_PRODMRP_CDPERIPRODU, @C_PRODMRP_QTHRSEGPROD, @C_PRODMRP_QTHRSEGPROD, @C_PRODMRP_QTLOTEFABDIA,
                                  @C_PRODMRP_QTPADPRODPCP, @C_PRODMRP_QTPADPRODUCAO, @C_PRODMRP_IDPROPORCAO, @C_PRODMRP_IDARREDONDA;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @C_PRODMRP_IDPROPORCAO = 'L' BEGIN
         SET @V_QTFABLOTEDIA = @C_PRODMRP_QTPADPRODPCP;
      END
      ELSE BEGIN
         IF @C_PRODMRP_IDPROPORCAO = 'N' BEGIN
            IF @V_QTAFABRICARR <= @C_PRODMRP_QTPADPRODPCP BEGIN
               SET @V_QTFABLOTEDIA = @V_QTAFABRICARR;
            END
            ELSE BEGIN
               IF @V_QTAFABRICARR = @C_PRODMRP_QTPADPRODUCAO BEGIN
                  SET @V_QTFABLOTEDIA = @C_PRODMRP_QTPADPRODPCP;
               END
               ELSE BEGIN
                  IF (@V_QTAFABRICARR > @C_PRODMRP_QTPADPRODUCAO) BEGIN
                     IF((CONVERT(INT, @V_QTAFABRICARR) % CONVERT(INT, @C_PRODMRP_QTPADPRODUCAO)) >= @C_PRODMRP_QTPADPRODPCP)OR
                       ((CONVERT(INT, @V_QTAFABRICARR) % CONVERT(INT,@C_PRODMRP_QTPADPRODUCAO)) =0) BEGIN
                        SET @V_QTFABLOTEDIA = @C_PRODMRP_QTPADPRODPCP;
                     END
                     ELSE BEGIN
                        SET @V_QTFABLOTEDIA = (CONVERT(INT, @V_QTAFABRICARR) % CONVERT(INT,@C_PRODMRP_QTPADPRODUCAO));
                     END;
                  END
                  ELSE BEGIN
                     IF ((CONVERT(INT, @V_QTAFABRICARR) % CONVERT(INT,@C_PRODMRP_QTPADPRODPCP)) >= @C_PRODMRP_QTPADPRODPCP)OR
                        ((CONVERT(INT, @V_QTAFABRICARR) % CONVERT(INT,@C_PRODMRP_QTPADPRODPCP))=0) BEGIN
                        SET @V_QTFABLOTEDIA = @C_PRODMRP_QTPADPRODPCP;
                     END
                     ELSE BEGIN
                        SET @V_QTFABLOTEDIA = (CONVERT(INT, @V_QTAFABRICARR) % CONVERT(INT,@C_PRODMRP_QTPADPRODPCP));
                     END;
                  END;
               END;
            END;
         END
         ELSE  BEGIN
            IF @C_PRODMRP_IDPROPORCAO = 'U' BEGIN
               SET @V_QTFABLOTEDIA = @V_QTAFABRICARR;
            END
            ELSE BEGIN
               IF @C_PRODMRP_IDPROPORCAO = 'D' BEGIN
                  IF @C_PRODMRP_IDARREDONDA = '1' BEGIN
                     IF ((CONVERT(INT,@V_QTAFABRICARR) % CONVERT(INT,@C_PRODMRP_QTPADPRODPCP)) <> 0) BEGIN
                        SET @V_QTFABLOTEDIA = (@V_QTAFABRICARR / (ROUND(@V_QTAFABRICARR / @C_PRODMRP_QTPADPRODPCP,0,0) + 1));
                     END
                     ELSE BEGIN
                        SET @V_QTFABLOTEDIA = (@V_QTAFABRICARR / (@V_QTAFABRICARR / @C_PRODMRP_QTPADPRODPCP));
                     END;
                  END
                  ELSE BEGIN
                     IF @C_PRODMRP_IDARREDONDA = '2' BEGIN
                        IF(@V_QTAFABRICARR   < @C_PRODMRP_QTPADPRODPCP)BEGIN
                           SET @V_QTFABLOTEDIA = 0;
                        END
                        ELSE BEGIN
                           SET @V_QTFABLOTEDIA = (@V_QTAFABRICARR / (ROUND(@V_QTAFABRICARR / @C_PRODMRP_QTPADPRODPCP,0,0)));
                        END;
                     END;
                  END;
               END;
            END;
         END;
      END;

      SET @V_NRTOTLOTEDIA = @C_PRODMRP_QTLOTEFABDIA;
      SET @V_DTAPRODUZIR  = @P_DTENTPROD;

      /* Qtde. total a fabricar do dia */
      IF @V_QTFABLOTEDIA > 0 BEGIN
         SET @V_QTTOTFABDIA = @V_QTAFABRICARR;
      END
      ELSE BEGIN
      /* VERIFICAR SE  NECESSARIO ESTE PONTO */
         SET @V_QTTOTFABDIA  = 0;
         DELETE FROM PROGPRODU
         WHERE
            CDFILIAL    = @P_CDFILIAL AND
            DTPROGPRODU = @P_DTMRP AND
            CDPRODUTO   = @P_CDPRODUTO AND
            DTENTPROD   = @P_DTENTPROD;
      END;


      SELECT @V_IDUTEQUIPLAPROD = MAX(IDUTEQUIPLAPROD)
      FROM PARAMAN
      WHERE CDFILIAL = @P_CDFILIAL;

      IF @V_IDUTEQUIPLAPROD IS NULL BEGIN
         SET @V_IDUTEQUIPLAPROD = 'N';
      END;

      WHILE ((@V_QTTOTFABDIA > 0) AND (@V_DTAPRODUZIR > GETDATE())) BEGIN
         /* verifica o tempo gasto para produzir o produto */
         IF @V_IDUTEQUIPLAPROD = 'N' BEGIN
            SELECT
               @V_QTHORASPROD = MAX(A.QTHRETFABRIC)
            FROM
               (SELECT
                   SUM(B.QTHRETFABRIC) AS QTHRETFABRIC
                FROM
                   (SELECT
                       P.CDPROCFABRIC,
                       E.NRORDETFAB,
                       MAX(ISNULL(T.QTHRETFABRPR, 0)) AS QTHRETFABRIC
                    FROM
                       PROCFABRICA P,
                       ETAFABRIC E LEFT JOIN TEMPOETAFABR T ON (E.CDFILIAL     = T.CDFILIAL)      AND
                                                               (E.CDPRODUTO    = T.CDPRODUTO)     AND
                                                               (E.CDPROCFABRIC = T.CDPROCFABRIC)  AND
                                                               (E.CDETAPAPROD  = T.CDETAPAPROD)   AND
                                                               (@V_QTFABLOTEDIA BETWEEN T.VRINIQTFABPR AND T.VRFINQTFABPR)
                    WHERE
                       (P.CDFILIAL     = @P_CDFILIAL)          AND
                       (P.CDPRODUTO    = @P_CDPRODUTO) AND
                       (P.IDPROFABPADR = 'S')                  AND
                       (E.CDFILIAL     = P.CDFILIAL)           AND
                       (E.CDPRODUTO    = P.CDPRODUTO)          AND
                       (E.CDPROCFABRIC = P.CDPROCFABRIC)
                    GROUP BY
                       P.CDPROCFABRIC,
                       E.NRORDETFAB
                   ) B
               ) A;

            SET @V_DTAPRODUZIR = (@V_DTAPRODUZIR - (@V_QTHORASPROD/24) - (@C_PRODMRP_QTHRSEGPROD/24));

            /*SET @V_DTAPRODUZIR =  TEKNISA.BUSCA_DATA_PRODUCAO( @P_CDFILIAL, @P_CDPRODUTO, @C_PRODMRP_CDPERIPRODU,
                                                                @C_PRODMRP_QTLOTEFABDIA, @P_DTMRP, @V_DTAPRODUZIR, @P_QTAFABRICDIA, @V_GERACALE);*/

           EXEC BUSCA_DATA_PRODUCAO @P_CDFILIAL, @P_CDPRODUTO, @C_PRODMRP_CDPERIPRODU, @C_PRODMRP_QTLOTEFABDIA,
                                     @P_DTMRP, @V_DTAPRODUZIR, @P_QTAFABRICDIA, @P_DTMRP, @V_GERACALE, @V_DTAPRODUZIR;




            IF @V_GERACALE = 'M' BEGIN
               INSERT INTO INCONSMRP
               (CDFILIAL, DTPROGPRODIN, CDPRODUTO, IDINCONSMRP)
               (SELECT @P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO, 'P'
                 WHERE NOT EXISTS (SELECT @P_CDFILIAL
                                FROM INCONSMRP
                                WHERE
                                   CDFILIAL     = @P_CDFILIAL  AND
                                   DTPROGPRODIN = @P_DTMRP     AND
                                   CDPRODUTO    = @P_CDPRODUTO AND
                                   IDINCONSMRP  = 'P'));
               BREAK;
            END
            ELSE BEGIN
               IF @V_GERACALE = 'C' BEGIN
                  INSERT INTO INCONSMRP
                  (CDFILIAL, DTPROGPRODIN, CDPRODUTO, IDINCONSMRP)
                  (SELECT @P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO, 'C'
                    WHERE NOT EXISTS (SELECT @P_CDFILIAL
                                   FROM INCONSMRP
                                   WHERE
                                      CDFILIAL     = @P_CDFILIAL   AND
                                      DTPROGPRODIN = @P_DTMRP      AND
                                      CDPRODUTO    = @P_CDPRODUTO  AND
                                      IDINCONSMRP  = 'C'));
                  BREAK;
               END;
            END;

            IF @V_GERACALE = 'S' BEGIN
               SET @V_LOTEDISPON = 'S';
            END;
            ELSE BEGIN
               SET @V_LOTEDISPON = 'N';
            END;


            IF (( @V_LOTEDISPON = 'S') AND (@V_DTAPRODUZIR > GETDATE())) BEGIN
               SELECT
                  @V_NRSEQLOTEDIA=MAX(NRSEQLOTEDIA)
               FROM
                  CALEPRODMRP
               WHERE
                  (CDFILIAL              = @P_CDFILIAL)  AND
                  (DTPROGPRODCP          = @P_DTMRP)     AND
                  (CDPRODUTO             = @P_CDPRODUTO) AND
                  CONVERT(DATETIME, DTCONCPROMRP, 103) = CONVERT(DATETIME, @V_DTAPRODUZIR, 103);

               IF @V_NRSEQLOTEDIA IS NULL BEGIN
                  SET @V_NRSEQLOTEDIA = '001';
               END
               ELSE BEGIN
                  SET @V_NRSEQLOTEDIA = RIGHT(REPLICATE('0',3) + CONVERT(VARCHAR, CONVERT(INT,@V_NRSEQLOTEDIA) + 1),3);
               END;
            END;
         END
         ELSE BEGIN

            SET @V_QTEQUIPPRODU =  @V_QTFABLOTEDIA;
            SET @V_DTPRODEQUIP = @V_DTAPRODUZIR;
            SET @V_QTDEMINUTOSUTI = 0;
            SET @V_CDCHAVE = 'M';
/*VERIFICA SE EXISTE ATIVIDADES CADASTRADAS PARA O PRODUTO
  ELAS SO NECESSARIAS PARA O CALCULO DO TEMPO */
            SELECT @V_CONTATIV = COUNT(*)
            FROM
               PROCFABRICA P, ETAFABRIC E, INSPETAPA I,
               RECURETAPA R
            WHERE
               (P.CDFILIAL     = @P_CDFILIAL) AND
               (P.CDPRODUTO    = @P_CDPRODUTO) AND
               (P.IDPROFABPADR = 'S')AND
               (QTHRUTRECUR > 0) AND
               (E.CDFILIAL     = P.CDFILIAL) AND
               (E.CDPRODUTO    = P.CDPRODUTO) AND
               (E.CDPROCFABRIC = P.CDPROCFABRIC) AND
                I.CDFILIAL     = E.CDFILIAL AND
                I.CDPRODUTO    = E.CDPRODUTO AND
                I.CDPROCFABRIC = E.CDPROCFABRIC AND
                I.CDETAPAPROD  = E.CDETAPAPROD AND
                R.CDFILIAL  =  I.CDFILIAL AND
                R.CDPRODUTO =   I.CDPRODUTO AND
                R.CDPROCFABRIC = I.CDPROCFABRIC AND
                R.CDETAPAPROD = I.CDETAPAPROD AND
                R.CDINSPECAO = I.CDINSPECAO AND
                R.NRINSPETAPA = I.NRINSPETAPA;

            IF @V_CONTATIV = 0 BEGIN
               INSERT INTO INCONSMRP (CDFILIAL, DTPROGPRODIN, CDPRODUTO, IDINCONSMRP)
               (SELECT @P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO, 'A'
                WHERE NOT EXISTS (SELECT @P_CDFILIAL
                                  FROM INCONSMRP
                                  WHERE
                                     CDFILIAL     = @P_CDFILIAL          AND
                                     DTPROGPRODIN = @P_DTMRP             AND
                                     CDPRODUTO    = @P_CDPRODUTO AND
                                     IDINCONSMRP = 'A'));
               BREAK;
            END;


            DECLARE C_DADOS CURSOR FOR
               SELECT
                  E.NRORDETFAB, I.NRINSPETAPA, NRORDUTRECUR,
                  I.CDINSPECAO, I.CDPROCFABRIC, I.CDETAPAPROD, CDGRUPOEQUIPA,
                  I.NRORDINSETAP, QTHRUTRECUR, R.IDRECURETAPA, QTHRSETUPRECUR, NRRECURETAPA,
                  (SELECT
                      MAX(QTHRUTRECUR)AS QTDEHORAMAX
                     FROM
                        RECURETAPA
                     WHERE
                         CDFILIAL = P.CDFILIAL AND
                         CDPRODUTO = P.CDPRODUTO AND
                         CDPROCFABRIC = P.CDPROCFABRIC AND
                         CDETAPAPROD = E.CDETAPAPROD AND
                         CDINSPECAO = R.CDINSPECAO AND
                         NRINSPETAPA = R.NRINSPETAPA AND
                         NRORDUTRECUR =  R. NRORDUTRECUR) QTHRRECURSO,
                         P.CDFILIAL+@P_CDPRODUTO+I.CDPROCFABRIC+I.CDETAPAPROD+I.CDINSPECAO+I.NRINSPETAPA AS CDCHAVE
               FROM
                  PROCFABRICA P, ETAFABRIC E, INSPETAPA I,
                  RECURETAPA R
               WHERE
                  (P.CDFILIAL     = @P_CDFILIAL) AND
                  (P.CDPRODUTO    = @P_CDPRODUTO) AND
                  (P.IDPROFABPADR = 'S')AND
                  (QTHRUTRECUR > 0) AND
                  (E.CDFILIAL     = P.CDFILIAL) AND
                  (E.CDPRODUTO    = P.CDPRODUTO) AND
                  (E.CDPROCFABRIC = P.CDPROCFABRIC) AND
                   I.CDFILIAL     = E.CDFILIAL AND
                   I.CDPRODUTO    = E.CDPRODUTO AND
                   I.CDPROCFABRIC = E.CDPROCFABRIC AND
                   I.CDETAPAPROD  = E.CDETAPAPROD AND
                   R.CDFILIAL  =  I.CDFILIAL AND
                   R.CDPRODUTO =   I.CDPRODUTO AND
                   R.CDPROCFABRIC = I.CDPROCFABRIC AND
                   R.CDETAPAPROD = I.CDETAPAPROD AND
                   R.CDINSPECAO = I.CDINSPECAO AND
                   R.NRINSPETAPA = I.NRINSPETAPA
               ORDER BY
                  E.NRORDETFAB, I.NRORDINSETAP, NRORDUTRECUR, I.CDINSPECAO, I.NRINSPETAPA;

            OPEN C_DADOS;

            FETCH NEXT FROM C_DADOS INTO @C_DADOS_NRORDETFAB, @C_DADOS_NRINSPETAPA, @C_DADOS_NRORDUTRECUR,
                                         @C_DADOS_CDINSPECAO, @C_DADOS_CDPROCFABRIC, @C_DADOS_CDETAPAPROD,
                                         @C_DADOS_CDGRUPOEQUIPA, @C_DADOS_NRORDINSETAP, @C_DADOS_QTHRUTRECUR,
                                         @C_DADOS_IDRECURETAPA, @C_DADOS_QTHRSETUPRECUR, @C_DADOS_NRRECURETAPA,
                                         @C_DADOS_QTHRRECURSO, @C_DADOS_CDCHAVE;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               /* PARA CONSIDERAR ATIVIDADES DA MESMA PRIORIDADE*/
               IF @V_CDCHAVE <> @C_DADOS_CDCHAVE BEGIN
                  SET @V_CDCHAVE = @C_DADOS_CDCHAVE;
                  SET @V_DTATIVANT =  @V_DTPRODEQUIP;
               END
               ELSE BEGIN
                  SET @V_DTPRODEQUIP = @V_DTATIVANT;
               END;

               IF @C_DADOS_IDRECURETAPA = 'H' BEGIN
                  SET @V_DTPRODEQUIP = @V_DTPRODEQUIP - (@C_DADOS_QTHRRECURSO/24) - (ISNULL(@C_DADOS_QTHRSETUPRECUR,0)/24);
                  SET @V_DTATIVANT = @V_DTPRODEQUIP;
               END
               ELSE BEGIN

                  DECLARE C_EQUIPAMENTOS CURSOR FOR
                     SELECT NRORDUTILEQUIP, CDEQUIPPRO, VRCAPEQUIPPROD, QTHRUTIEQUIPROD,
                                            IDLIBERAEQUIPA,
                                            IDEQUIPPADRAO
                                        FROM  EQUIPRECUETAPA
                                        WHERE
                                            CDFILIAL =  @P_CDFILIAL AND
                                            CDPRODUTO = @P_CDPRODUTO AND
                                            CDPROCFABRIC = @C_DADOS_CDPROCFABRIC AND
                                            CDETAPAPROD = @C_DADOS_CDETAPAPROD AND
                                            CDINSPECAO = @C_DADOS_CDINSPECAO AND
                                            NRINSPETAPA = @C_DADOS_NRINSPETAPA AND
                                            NRRECURETAPA = @C_DADOS_NRRECURETAPA
                                        ORDER BY IDEQUIPPADRAO DESC,  NRORDUTILEQUIP;

                  OPEN C_EQUIPAMENTOS;
                  FETCH NEXT FROM C_EQUIPAMENTOS INTO  @C_EQUIPAMENTOS_NRORDUTILEQUIP, @C_EQUIPAMENTOS_CDEQUIPPRO,
                                                       @C_EQUIPAMENTOS_VRCAPEQUIPPROD, @C_EQUIPAMENTOS_QTHRUTIEQUIPROD,
                                                       @C_EQUIPAMENTOS_IDLIBERAEQUIPA, @C_EQUIPAMENTOS_IDEQUIPPADRAO;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SET @V_QTDEMINUTOSUTI = (@V_QTEQUIPPRODU * @C_EQUIPAMENTOS_QTHRUTIEQUIPROD)/ @C_EQUIPAMENTOS_VRCAPEQUIPPROD;
                     SET @V_DTPRODEQUIP = @V_DTPRODEQUIP - ((@V_QTDEMINUTOSUTI)/24) - ( ISNULL(@C_DADOS_QTHRSETUPRECUR,0)/24);

                     SET @V_DTAPRODUZIR = TEKNISA.VALIDA_DATA_PRODUCAO( @P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO,
                                                                     @V_DTPRODEQUIP, @V_NRTOTLOTEDIA,
                                                                     @C_PRODMRP_CDPERIPRODU, (@V_QTDEMINUTOSUTI/24),
                                                                     @C_EQUIPAMENTOS_CDEQUIPPRO, GETDATE());

                     SET @V_DTPRODFINAL = @V_DTAPRODUZIR + (@V_QTDEMINUTOSUTI/24);

                     IF @V_DTAPRODUZIR IS NULL BEGIN
                        SET @V_DTPRODEQUIP = @V_DTPRODEQUIP + ((@V_QTDEMINUTOSUTI)/24) + ( ISNULL(@C_DADOS_QTHRSETUPRECUR,0)/24);
                        SET @V_QTEQUIPPRODU = @V_QTFABLOTEDIA;
                     END
                     ELSE BEGIN
                     /* BUSCA O SEQUENCIAL DO LOTE DIA */
                        SELECT
                           @V_NRSEQLOTEDIA = MAX(NRSEQLOTEDIA)
                        FROM
                           CALEPRODMRP
                        WHERE
                           (CDFILIAL              = @P_CDFILIAL)          AND
                           (DTPROGPRODCP          = @P_DTMRP)             AND
                           (CDPRODUTO             = @P_CDPRODUTO) AND
                           (CONVERT(DATETIME, DTCONCPROMRP, 103) = CONVERT( DATETIME, @V_DTAPRODUZIR, 103));

                        IF @V_NRSEQLOTEDIA IS NULL BEGIN
                           SET @V_NRSEQLOTEDIA = '001';
                        END
                        ELSE BEGIN
                           SET @V_NRSEQLOTEDIA = RIGHT(REPLICATE('0',3) + CONVERT(VARCHAR, CONVERT(INT,@V_NRSEQLOTEDIA) + 1),3);
                        END;


                        INSERT INTO CALENDEQUIPAPRO( CDFILIAL, DTPROGUTEQUIP, CDPRODUTO, DTCONCPRODEQUIP,
                                                  DTHRINIUTEQUIP, DTHRFINUTEQUIP, NRSEQLOTEDIAPRO,
                                                  CDEQUIPPRO, CDGRUPOEQUIPA, QTPRODPROCEQUIP, CDETAPAPROD, CDINSPECAO, NRINSPETAPAPROD)
                            VALUES( @P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO, @V_DTAPRODUZIR,
                                    @V_DTAPRODUZIR, @V_DTPRODFINAL, @V_NRSEQLOTEDIA,
                                    @C_EQUIPAMENTOS_CDEQUIPPRO, @C_DADOS_CDGRUPOEQUIPA, @V_QTEQUIPPRODU, @C_DADOS_CDETAPAPROD,
                                    @C_DADOS_CDINSPECAO, @C_DADOS_NRINSPETAPA);

                        SET @V_DTPRODEQUIP = @V_DTPRODFINAL;
                        SET @V_QTEQUIPPRODU = @V_QTFABLOTEDIA - @V_QTEQUIPPRODU;

                        IF @V_QTEQUIPPRODU = 0 BEGIN
                           BREAK;
                        END;
                        SET @V_DTPRODEQUIP = @V_DTAPRODUZIR;
                        SET @V_DTATIVANT = @V_DTAPRODUZIR;
                     END;

                     FETCH NEXT FROM C_EQUIPAMENTOS INTO  @C_EQUIPAMENTOS_NRORDUTILEQUIP, @C_EQUIPAMENTOS_CDEQUIPPRO,
                                                       @C_EQUIPAMENTOS_VRCAPEQUIPPROD, @C_EQUIPAMENTOS_QTHRUTIEQUIPROD,
                                                       @C_EQUIPAMENTOS_IDLIBERAEQUIPA, @C_EQUIPAMENTOS_IDEQUIPPADRAO;
                  END;

                  CLOSE C_EQUIPAMENTOS;
                  DEALLOCATE C_EQUIPAMENTOS;

/* SE NO EXISTIR EQUIPAMENTOS DISPONIVEIS PARA A PRODUO*/
                  IF(@V_QTEQUIPPRODU > 0)BEGIN

                     INSERT INTO INCONSMRP (CDFILIAL, DTPROGPRODIN, CDPRODUTO, IDINCONSMRP)
                         (SELECT @P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO, 'E'
                          WHERE NOT EXISTS (SELECT @P_CDFILIAL
                                            FROM INCONSMRP
                                            WHERE
                                               CDFILIAL     = @P_CDFILIAL          AND
                                               DTPROGPRODIN = @P_DTMRP             AND
                                               CDPRODUTO    = @P_CDPRODUTO AND
                                               IDINCONSMRP = 'E'));
                     BREAK;
                  END;
               END;

               FETCH NEXT FROM C_DADOS INTO @C_DADOS_NRORDETFAB, @C_DADOS_NRINSPETAPA, @C_DADOS_NRORDUTRECUR,
                                         @C_DADOS_CDINSPECAO, @C_DADOS_CDPROCFABRIC, @C_DADOS_CDETAPAPROD,
                                         @C_DADOS_CDGRUPOEQUIPA, @C_DADOS_NRORDINSETAP, @C_DADOS_QTHRUTRECUR,
                                         @C_DADOS_IDRECURETAPA, @C_DADOS_QTHRSETUPRECUR, @C_DADOS_NRRECURETAPA,
                                         @C_DADOS_QTHRRECURSO, @C_DADOS_CDCHAVE;
            END;
            CLOSE C_DADOS;
            DEALLOCATE C_DADOS;

            /*SE O PROCESSO DE FABRICAO S POSSUI ATIVIDADES DE HABILIDADADE E NENHUMA DE EQUIPAMENTO*/
            IF(@V_DTPRODEQUIP <> ISNULL(@V_DTAPRODUZIR, GETDATE()))AND( @V_QTEQUIPPRODU > 0)BEGIN
               SET @V_DTAPRODUZIR = @V_DTPRODEQUIP;
               SET @V_QTEQUIPPRODU = 0;

               /* BUSCA O SEQUENCIAL DO LOTE DIA */
               SELECT
                  @V_NRSEQLOTEDIA = MAX(NRSEQLOTEDIA)
               FROM
                  CALEPRODMRP
               WHERE
                  (CDFILIAL              = @P_CDFILIAL)          AND
                  (DTPROGPRODCP          = @P_DTMRP)             AND
                  (CDPRODUTO             = @P_CDPRODUTO) AND
                  (CONVERT(DATETIME, CONVERT(VARCHAR, DTCONCPROMRP, 103), 103) <= CONVERT(DATETIME, CONVERT(VARCHAR, @V_DTAPRODUZIR, 103), 103));

               IF @V_NRSEQLOTEDIA IS NULL BEGIN
                  SET @V_NRSEQLOTEDIA = '001';
               END
               ELSE BEGIN
                  SET @V_NRSEQLOTEDIA = RIGHT(REPLICATE('0',3) + CONVERT(VARCHAR, CONVERT(INT,@V_NRSEQLOTEDIA) + 1),3);
               END;

            END;
            SET @V_LOTEDISPON = 'S';
         END;


         IF ((@V_LOTEDISPON = 'S') AND (@V_DTAPRODUZIR > GETDATE())) BEGIN
             
            IF @V_QTFABLOTEDIA <> 0 BEGIN

               SELECT @V_IDSUBOPSEMIACA = ISNULL(MAX(IDSUBOPSEMIACA),'N')
               FROM PARAMAN
               WHERE CDFILIAL = @P_CDFILIAL;

               IF @V_IDSUBOPSEMIACA = 'S' BEGIN
                  IF @P_IDSUBOPINSU = 'S' BEGIN
                     SET @V_NRORDENAOP    = @P_NRORDENAOP;
                     SET @V_NRORDENASUBOP = @P_NRORDENASUBOP;
                  END
                  ELSE BEGIN
                     SELECT @V_NRORDENAOP = RIGHT(REPLICATE('0',10)+RTRIM(CONVERT(CHAR, CONVERT(NUMERIC, ISNULL(MAX(NRORDENAOP),'0')) + 1)),10)
                     FROM CALEPRODMRP
                     WHERE CDFILIAL = @P_CDFILIAL
                       AND DTPROGPRODCP = @P_DTMRP;

                     SET @V_NRORDENASUBOP = '0';
                  END;
               END
               ELSE BEGIN
                  SET @V_NRORDENAOP    = '0000000000';
                  SET @V_NRORDENASUBOP = '0';
               END;

               IF @V_QTFABLOTEDIA >0 BEGIN
                  UPDATE PROGPRODU
                     SET  QTAFABRICARR = ISNULL(QTAFABRICARR,0) + @V_QTFABLOTEDIA
                   WHERE
                     (CDFILIAL    = @P_CDFILIAL)     AND
                     (DTPROGPRODU = @P_DTMRP)        AND
                     (CDPRODUTO   = @P_CDPRODUTO)    AND
                     CONVERT(DATETIME, DTENTPROD, 103) = CONVERT(DATETIME, @P_DTENTPROD, 103)
               END;

               
               INSERT INTO CALEPRODMRP
                  (CDFILIAL, DTPROGPRODCP, CDPRODUTO, DTCONCPROMRP, NRSEQLOTEDIA, QTAFABRICMRP, NRORDENAOP, NRORDENASUBOP, CDPRODFINAL, QTAFABRICDIA,  NRORDEMPROD )
               VALUES
                  (@P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO, @V_DTAPRODUZIR, @V_NRSEQLOTEDIA, @V_QTFABLOTEDIA, @V_NRORDENAOP, @V_NRORDENASUBOP, @P_CDPRODFINAL, @P_QTAFABRICDIA, @V_NRORDEMPROD);
             
            END;
         END;
         SET @V_QTTOTFABDIA = @V_QTTOTFABDIA - @V_QTFABLOTEDIA;
         IF @C_PRODMRP_IDPROPORCAO = 'L' OR
            @C_PRODMRP_IDPROPORCAO = 'N' BEGIN
            SET @V_QTFABLOTEDIA = @C_PRODMRP_QTPADPRODPCP;
         END;
       

      END;


      IF @V_DTAPRODUZIR < GETDATE()BEGIN
         INSERT INTO INCONSMRP
             (CDFILIAL, DTPROGPRODIN, CDPRODUTO, IDINCONSMRP)
             (SELECT @P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO, 'P'
              WHERE NOT EXISTS (SELECT @P_CDFILIAL
                                FROM INCONSMRP
                                WHERE
                                   CDFILIAL     = @P_CDFILIAL          AND
                                   DTPROGPRODIN = @P_DTMRP             AND
                                   CDPRODUTO    = @P_CDPRODUTO AND
                                   IDINCONSMRP  = 'P'));
      END;
      FETCH NEXT FROM C_PRODMRP INTO @C_PRODMRP_CDPERIPRODU, @C_PRODMRP_QTHRSEGPROD, @C_PRODMRP_QTHRSEGPROD, @C_PRODMRP_QTLOTEFABDIA,
                                     @C_PRODMRP_QTPADPRODPCP, @C_PRODMRP_QTPADPRODUCAO, @C_PRODMRP_IDPROPORCAO, @C_PRODMRP_IDARREDONDA;

   END;
   CLOSE C_PRODMRP;
   DEALLOCATE C_PRODMRP;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_CALE_PRODU','5.05.016';
GO
